#ifndef __SIGNATURE_HEADER_INCLUDED__
#define __SIGNATURE_HEADER_INCLUDED__

#include <alert.h>

struct criteria {
	struct criteria	*next;
	char		*crit;
	char		*args;

	/* If the low bit is 1 then negate */
	u_int8_t	negate;
};

struct rule {
	/* Realm */
	struct realm	*realm;

	/* Rule criteria */
	unsigned int num_criteria;
	struct criteria	*criteria;
	struct criteria	*crit_end;

	/* Modifiers */
	struct criteria	*modifier;

	struct alert	alert;
};

#ifndef __PLUGIN__
void signature_stats(void);

struct rule *signature_rule(char *);
void signature_abort(struct rule *);
int signature_criteria(struct rule *, int, char *, char *);
int signature_modifier(struct rule *, int, char *, char *);
int signature_alert(struct rule *, char *);
int signature_commit(struct rule *);
#else
typedef struct rule *(*proc_sig_rule)(char *);
typedef void (*proc_sig_abort)(struct rule *);
typedef int (*proc_sig_criteria)(struct rule *, int, char *, char *);
#define proc_sig_modifier proc_sig_criteria
typedef int (*proc_sig_alert)(struct rule *, char *);
typedef int (*proc_sig_commit)(struct rule *);
#endif

#endif /* __SIGNATURE_HEADER_INCLUDED__ */
